# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: hilare2.tcl,v 1.5 2003/02/09 16:31:29 matthieu Exp $
#----------------------------------------------------------------------
package provide Gdhe::models 1.0

##
## Dessin d'hilare2
##
proc hilare2 {{l "unload"}} {

    object Hilare2 {
	cullFace True
	concave False
	color 200 200 200
	# prisme de base - partie inferieure
	prism 8 0.0 0.0 0.2 \
	    -.60 -.29 .26 \
	    -.60 .29 .26 \
	    -.54 .351 .26 \
	    .54 .351 .26 \
	    .60 .29 .26 \
	    .60 -.29 .26 \
	    .54 -.351 .26 \
	    -.54 -.351 .26 
	# prisme de base - partie superieure 
	prism 6 0.0 0.0 0.33 \
	    -.60 -.29 .45 \
	    -.60 .29 .45 \
	    -.54 .351 .45 \
	    .24 .351 .45 \
	    .24 -.351 .45 \
	    -.54 -.351 .45

    color 220 220 220
    # attache de remorque
    box -0.64 .0 .07 .14 .24 .01
    color 0 0 0
    box -0.58 .0 .07 .01 .14 .20
    color 40 50 100
    cylinder -0.64 0 0.08 z 0.07 0.12

	# sick
	color 20 20 200
	box .375 .0 .55 .15 .15 .07
	box .325 .0 .47 .05 .15 .08
	box .375 .0 .45 .15 .15 .02
	color 20 20 20
	box .39 .0 .47 .08 .10 .08
	# plateau superieur
	color 150 150 150 
	box -0.05 0.0 .77 .55 .60 .150
	color 30 30 30 
	# bordure superieur du corps 
	# prism 6 0.0 0.0 0.005 \
	    -.601 -.29 .774 \
	    -.601 .29 .774 \
	    -.54 .352 .774 \
	    .25 .352 .774  \
	    .25 -.352 .774 \
	    -.54 -.352 .774
	# bumper
	prism 8 0.0 0.0 0.04 \
	    -.655 -.29 .25 \
	    -.655 .29 .25 \
	    -.54 .405 .25 \
	    .54 .405 .25 \
	    .655 .29 .25 \
	    .655 -.29 .25 \
	    .54 -.405 .25 \
	    -.54 -.405 .25
	# us 
	box .365 .352 .31 .04 .02 .12
	box .499 .352 .31 .04 .02 .12
	box .602 .15 .31 .02 .04 .12
	box .602 .052 .31 .02 .04 .12
	box .602 -.052 .31 .02 .04 .12 
	box .602 -.15 .31 .02 .04 .12
	box .499 -.352 .31 .04 .02 .12
	box .365 -.352 .31 .04 .02 .12
	box .22 -.358 .365 .04 .02 .12
	box .075 -.358 .365 .04 .02 .12
	box -.045 -.358 .365 .04 .02 .12
	box -.195 -.358 .365 .04 .02 .12
	box  -.365 -.352 .31 .04 .02 .12
	box -.499 -.352 .31 .04 .02 .12
	box -.602 -.150 .31 .02 .04 .12
	box -.602 -.052 .31 .02 .04 .12
	box -.602 .052 .31 .02 .04 .12
	box -.602 .150 .31 .02 .04 .12
	box -.499 .352 .31 .04 .02 .12
	box -.365 .352 .31 .04 .02 .12
	box -.195 .358 .365 .04 .02 .12
	box -.045 .358 .365 .04 .02 .12
	box .075 .358 .365 .04 .02 .12
	box .22 .358 .365 .04 .02 .12
	
	color 0 80 50 
	# roues motrices 
	cylinder 0.0 0.28 0.15 y 0.30 0.07
	cylinder 0.0 -0.35 0.15 y 0.30 0.07
	# roues folles
	cylinder .58 .25 .075 y .15 .1
	cylinder .58 -.35 .075 y .15 .1
	cylinder -.42 .25 .075 y .15 .1
	cylinder -.42 -.35 .075 y .15 .1
	
	color 150 150 150
	# flasques des roues 
	cylinder 0.0 0.35 0.15 y 0.25 0.001
	cylinder 0.0 -0.351 0.15 y 0.25 0.001
	cylinder .58 .249 .075 y .125 .102
	cylinder .58 -.351 .075 y .125 .102
	cylinder -.42 .249 .075 y .125 .102
	cylinder -.42 -.351 .075 y .125 .102
	box 0.05 0.0 0.05 0.25 0.50 0.3

	color 200 100 0
	# supports des roues folles
	cylinder .5 .3 .225 z .09 .025
	cylinder .5 -.3 .225 z .09 .025
	cylinder  -.5 .3 .225 z .09 .025
	cylinder -.5 -.3 .225 z .09 .025
	prism 5 0.0 0.03 0.0 \
	    .455 .285 .225 \
	    .455 .285 .045 \
	    .575 .285 .0 \
	    .655 .285 .025 \
	    .545 .285 .225
	prism 5 0.0 0.03 0.0 \
	    .455 -.315 .225 \
	    .455 -.315 .045 \
	    .575 -.315 .0 \
	    .655 -.315 .025 \
	    .545 -.315 .225
	prism 5 0.0 0.03 0.0 \
	    -.545 .285 .225 \
	    -.545 .285 .045 \
	    -.425 .285 .0 \
	    -.345 .285 .025 \
	    -.455 .285 .225 
	prism 5 0.0 0.03 0.0 \
	    -.545 -.315 .225 \
	    -.545 -.315 .045 \
	    -.425 -.315 .0 \
	    -.345 -.315 .025 \
	    -.455 -.315 .225
	color 80 80 80
	# axe des roues motrices
	cylinder 0.0 -0.352 0.15 y 0.08 0.704
	
    }
    if {![string compare $l load ]} {
	# Dessin le container dans le robot
	object container_h2bis {
	    color 180 13 50
	    # :cube container
	    box -.15 0.0 .92	.4 .5 .12
	}
    }
}

#----------------------------------------------------------------------
### 
### platine
###
proc h2_platform {azi site} {
    pushMatrix
    translate 0.2 0 0.92
    object h2PlatineInf {
        color 30 30 30
        box -0.02 0.0 0 0.08 0.05 0.05
        color 180 180 180
        cylinder -0.075 0 0.025 x 0.012 0.02
    }
    rotate $azi 0 0 1
    object h2PlatineMid {
        color 30 30 30
        box -0.02 0 0.051 0.08 0.05 0.05
        color 180 180 180
        cylinder -0.075 0 0.075 x 0.012 0.02
        translate 0 0 0.075
    }
    rotate $site 0 -1 0
    object h2PlatineSup {
        color 30 30 30
        box 0 -0.028 -0.01 0.02 0.005 0.05
        box 0  0.028 -0.01 0.02 0.005 0.05
        color 100 100 100
        box 0 0 0.04 0.02 0.2 0.005
        color 20 20 20
        box -0.013 0.07 0.045 0.053 0.045 0.035
        color 70 70 70
        cylinder 0.01 0.07 0.065 x 0.028 0.01
        cylinder 0.02 0.07 0.065 x 0.028 0.05 0.02
        cylinder 0.04 0.07 0.065 x 0.05 0.008
        color 20 20 20
        box -0.013 -0.07 0.045 0.053 0.045 0.035
        color 70 70 70
        cylinder 0.01 -0.07 0.065 x 0.028 0.01
        cylinder 0.02 -0.07 0.065 x 0.028 0.05 0.02
        cylinder 0.04 -0.07 0.065 x 0.05 0.008
    }
    popMatrix
}

proc hilare2_old {{l unloaded}} {

    object Hilare2Old { 
	cullFace True

	color 200 200 200
	# prisme de base
	prism 8 0.0 0.0 0.530 \
	    -.60 -.29 0.29\
	    -.60 .29 0.29\
	    -.54 .351 0.29 \
	    .54 .351 0.29\
	    .60  .29 0.29\
	    .60 -.29 0.29 \
	    .54 -.351 0.29 \
	    -.54 -.351 0.29

	color 30 30 30 	
	# sick
	color 20 20 200
	box .375 .0 .55 .15 .15 .07
	box .325 .0 .47 .05 .15 .08
	box .375 .0 .45 .15 .15 .02
	color 20 20 20
	box .39 .0 .47 .08 .10 .08


	# plateau superieur
	box -.04 0.0 .77 .56 .64 .120
	# support de la platine 
	color 100 100 100
	box .40 .0 .77 .22 .23 .08
	# moteur de la platine
	color 255 255 255
	cylinder .40 .0 .84 z .22 .09
	
	# bordure du prisme de base
	color 30 30 30
	#prism 8 0.0 0.0 0.005 \
	    -.601 -.29 .774 \
	   -.601 .29 .774 \
	    -.54 .352 .774 \
	    .54 .352 .774 \
	    .601 .29 .774 \
	    .601 -.29 .774 \
	    .54 -.352 .774 \
	    -.54 -.352 .774
	# bumper
	prism 8 0.0 0.0 0.04 \
	    -.655 -.29   .25\
	    -.655 .29    .25\
	    -.54  .405   .25\
	    .54   .405   .25\
	    .655  .29    .25\
	    .655  -.29   .25\
	    .54   -.405  .25\
	    -.54  -.405	 .25
	# ultra-sons
	box  .365  .352 .31  .04 .02 .12; # us1
	box  .499  .352 .31  .04 .02 .12; # us2
	box  .602  .15  .31  .02 .04 .12; # us5
	box  .602  .052 .31  .02 .04 .12; # us6
	box  .602 -.052 .31  .02 .04 .12; # us7
	box  .602 -.15  .31  .02 .04 .12; # us 8
	box  .499 -.352 .31  .04 .02 .12; # us 11
	box  .365 -.352 .31  .04 .02 .12; # us12
	box  .22  -.358 .365 .04 .02 .12; # us 13
	box  .075 -.358 .365 .04 .02 .12; # us 14
	box -.045 -.358 .365 .04 .02 .12; # us 15
	box -.195 -.358 .365 .04 .02 .12; # us 16
	box -.365 -.352 .31  .04 .02 .12; # us 17
	box -.499 -.352 .31  .04 .02 .12; # us 18
	box -.602 -.150 .31  .02 .04 .12; # us 21
	box -.602 -.052 .31  .02 .04 .12; # us 22
	box -.602  .052 .31  .02 .04 .12; # us 23
	box -.602  .150 .31  .02 .04 .12; # us 24
	box -.499  .352 .31  .04 .02 .12; # us 27
	box -.365  .352 .31  .04 .02 .12; # us 28
	box -.195  .358 .365 .04 .02 .12; # us 29
	box -.045  .358 .365 .04 .02 .12; # us 30
	box  .075  .358 .365 .04 .02 .12; # us 31
	box  .22   .365 .358 .04 .02 .12; # us 32
	# Roue motrices
	color 0 80 50
	cylinder 0.0  0.28 0.15 y 0.30 0.07; # droite
	cylinder 0.0 -0.35 0.15 y 0.30 0.07; # gauche
	# roues folles
	cylinder  .58  .25 .075 y .15 .1; # avant droite
	cylinder  .58 -.35 .075 y .15 .1; # avant gauche
	cylinder -.42  .25 .075 y .15 .1; # arriere droite
	cylinder -.42 -.35 .075 y .15 .1; # arriere gauche 
	color 150 150 150
	cylinder  .0   .35  .15  y .25  .001;	# 
	cylinder  .0  -.351 .15  y .25  .001;	# 
	cylinder  .58 -.351 .075 y .125 .102; # 
	cylinder  .58  .249 .075 y .125 .102; # 
	cylinder -.42  .249 .075 y .125 .102; # 
	cylinder -.42 -.351 .075 y .125 .102; # 
	# bloc moteur
	box 0.05 0.0 0.05 0.25 0.50 0.3;
	# axes support roues folles
	color 200 100 0
	cylinder  .5 -.3 .225 z .09 .025; # avant gauche
	cylinder  .5  .3 .225 z .09 .025; # avant droit
	cylinder -.5  .3 .225 z .09 .025; # arriere droit
	cylinder -.5 -.3 .225 z .09 .025;	# arriere gauche
	# support de la roue folle avant droite
	prism 5 0.0 0.03 0.0 \
	    .455 .315 .225 \
	    .455 .315 .045 \
	    .575 .315 .0   \
	    .655 .315 .025 \
	    .545 .315 .225;
	# support de la roue folle avant gauche
	prism 5 0.0 0.03 0.0 \
	    .455 -.315 .225 \
	    .455 -.315 .045 \
	    .575 -.315 .0   \
	    .655 -.315 .025 \
	    .545 -.315 .225;
	# support de la roue folle arriere droite
	prism 5 0.0 0.03 0.0 \
	    -.545 .285 .225 \
	    -.545 .285 .045 \
	    -.425 .285 .0   \
	    -.345 .285 .025 \
	    -.455 .285 .225;
	# support de la roue folle arriere gauche
	prism 5 0.0 0.03 0.0 \
	    -.545 -.315 .225 \
	    -.545 -.315 .045 \
	    -.425 -.315 .0   \
	    -.345 -.315 .025 \
	    -.455 -.315 .225;
	# axe des roues motrices
	color 80 80 80
	cylinder 0.0 -0.352 0.15 y 0.08 0.704
    }
}

#----------------------------------------------------------------------
#
# Platine telemetre Laser d'h2
#
proc h2_platform_old {angle} {
    

    pushMatrix
    translate 0.4 0.0 0.93;

    rotate $angle 0 0 1
    object H2_platform {

	# telemetre laser
	color 255 80 0
	box 0.0 -0.23 .12 0.23 0.28 .08
	# plaque de base
	color 100 100 100
	box 0.0 0.0 0.0 .25 .32 .015
	# support camera
	box -.08 .11 .015 .075 .015 .34 
	box -.08 .06 .325 .05  .09  .015
	# Support laser
	box .0 -.115  .015 .25 .1   .075
	box .0 -.1725 .105 .25 .075 .11 
	# support miroir
	box -.08  .075  .015 .015 .075 .20
	box -.025 .0725 .13  .11  .01	 .08
	# Camera haute
	color 30 30 30
	box -.115 .015 .34 .15 .065 .055
	cylinder -.04 .015 .3675 x .04 .045
	# laser
	box .0 -.23 .121 .228 .282 .078
	# moteur site
	cylinder .005 .075 .17 y .035 .16
	# miroir
	prism 3 0.0 0.0 0.09 \
	    0.05 .065 .125 \
	    -.04 .065 .125 \
	    -.04 -.03 .125
	# fin de la liste 

    }
    popMatrix
    if {![string compare $l load ]} {
	# Dessin le container dans le robot
	object container_hilare2 {
	    color 180 13 50
	    # :cube container
	    box 	-.04 0.0 .90	.45 .55 .090
	}
    }
}
    

proc hilare2_drapeau_pmo { color_r color_g color_b } {
global faces_RS diametre_Drapeau

    pushMatrix
    color $color_r $color_g $color_b
 #   object h2_objet_drapeau {
	cullFace True

	#:cylinder de base

	cylinder -.48 0.0 0.78  z .1 0.2

	#:sphere du drapeau

	sphere -.48 0.0 1.00 $diametre_Drapeau $faces_RS
 #   }
    popMatrix
}
    

